﻿-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

local p
local spname,startTime,endTime
local phealth,phealthmax,ppower,ppowermax,ppactiveRegen,pshape
--[[lib.mytest=function(tab)
	tab["a"]=2
	end
cfg.mytab={}
cfg.mytab["a"]=3

lib.mytest2=function()
	lib.mytest(cfg.mytab)
	print(cfg.mytab["a"])
end]]


--[[local function Hedd_findclass()
	if lib.classes[cfg.class] and lib.classes[cfg.class][cfg.talenttree] then
		cfg.classfound=true
		if lib.classpreload[cfg.class] then
			lib.classpreload[cfg.class]()
		end
		lib.classes[cfg.class][cfg.talenttree]()
		return true
	end
	cfg.classfound=nil
	return false
end]]

lib.basicevents = function()
	function Heddevents.UNIT_POWER_FREQUENT(unit,powerType)
		if unit=="player" then
			--print(powerType)
			lib.UpdatePower(powerType)
		end
	end

	function Heddevents.UNIT_HEALTH_FREQUENT(unitID)
		if hedlib.isPlayer(unitID) or unitID=="target" then
			lib.UpdateHealth(unitID)
		end
	end
	
	--Heddevents.SPELL_UPDATE_USABLE=lib.UpdateAllSpells
	function Heddevents.SPELL_UPDATE_COOLDOWN()
		lib.UpdateAllSpells()
		--lib.UpdateSpell("gcd")
		--print(GetSpellCooldown(107428))
		--print("SPELL_UPDATE_USABLE")
	end
		
	function Heddevents.UNIT_AURA(unitID)
		--print(unitID)
		if unitID and cfg.watchunits[unitID] then --and UnitExists(unitID) 
			lib.UpdateAuraAll(unitID)
		end
		if unitID=="player" then
			--lib.UpdateMount()
			lib.UpdateHaste()
			lib.UpdatePower()
			lib.UpdateAllSpells()
			--print("Update on Aura")
			--lib.UpdateSpell("gcd")
		end
		if cfg.TrackAura.aura and cfg.aura[cfg.TrackAura.aura] and cfg.aura[cfg.TrackAura.aura].unit==unitID then 
			lib.UpdateAuraFrame()
		end
	end
	
	function Heddevents.PLAYER_TARGET_CHANGED()
		lib.UpdateTarget()
		lib.UpdateTargetCast()
		Heddevents.UNIT_AURA("target")
		Heddevents.UNIT_HEALTH_FREQUENT("target")
		lib.instance()
		lib.MainOptionsToggle()
		lib.ResourceOptionsToggle()
		if cfg.class=="DEATHKNIGHT" then lib.RunesOptionsToggle() end
		cfg.Update=true
	end
	
	function Heddevents.UNIT_PET(unitID)
		if unitID=="player" then
			lib.UpdatePet()
			Heddevents.UNIT_HEALTH_FREQUENT("pet")
		end
	end

	function Heddevents.PLAYER_EQUIPMENT_CHANGED(slot, hasItem)
		if InCombatLockdown() then
			cfg.combat_reset=true
		else
			Heddtalents_reload()
		end
	end
	
	--[[function Heddevents.COMPANION_UPDATE(...)
		print(...)
		lib.UpdateMount()
	end]]

	function Heddevents.UNIT_SPELLCAST_START(u, spellName, rank, castid, spellId)
		if u=="target" then
			lib.UpdateTargetCast(spellId)
			return
		end
		if castid=="0-0-0-0-0-0000000000" then return end
		if u=="player" then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_START "..spellName.." "..spellId) end
			lib.UpdateSpell(spellId)
			lib.UpdateSpell("gcd")
			lib.UpdateCast(spellId)
			-- lib.SpellSwitchMode()
			lib.UpdatePower(cfg.Power.type)
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_INTERRUPTED(u, spellName, rank, castid, spellId)
		if u=="target" then
			lib.UpdateTargetCast(spellId)
			return
		end
		if castid=="0-0-0-0-0-0000000000" then return end
		if u=="player" then
			lib.UpdateSpell(spellId)
			lib.UpdateSpell("gcd")
			if cfg.Casting.castid==castid then
				if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_INTERRUPTED "..spellName.." "..spellId) end
				lib.UpdateCast(spellId)
				lib.UpdatePower(cfg.Power.type)
				--lib.UpdateAllSpells()
			end
			cfg.Update=true
		end
	end
	
	Heddevents.UNIT_SPELLCAST_STOP=Heddevents.UNIT_SPELLCAST_INTERRUPTED
	
	function Heddevents.UNIT_SPELLCAST_DELAYED(u, spellName, rank, castid, spellId)
		if u=="target" then
			lib.UpdateTargetCast(spellId)
			return
		end
		if castid=="0-0-0-0-0-0000000000" then return end
		if u=="player" then
			lib.UpdateSpell(spellId)
			lib.UpdateSpell("gcd")
			if cfg.Casting.castid~=castid then
				if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_DELAYED "..spellName.." "..spellId) end
				lib.UpdateCast(spellId)
				lib.UpdatePower(cfg.Power.type)
				--lib.UpdateAllSpells()
			end
			cfg.Update=true
			return
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_SUCCEEDED(u, spellName, rank, castid, spellId)
		if u=="target" then
			lib.UpdateTargetCast(spellId)
			return
		end
		if castid=="0-0-0-0-0-0000000000" then return end
		if u=="player" and not cfg.res_spells[spellName] then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_SUCCEEDED "..spellName.." "..spellId) end
			lib.UpdateSpell(spellId,true)
			lib.UpdateSpell("gcd")
			if cfg.spells[cfg.id2spell[spellId]] and cfg.spells[cfg.id2spell[spellId]].oncast then cfg.spells[cfg.id2spell[spellId]].oncast() end
			lib.UpdateCast(spellId)
			lib.SaveCast(spellId,spellName)
			-- lib.SpellSwitchMode()
			lib.UpdatePower(cfg.Power.type)
			--print(spellId.." - "..spellName)
			--print(time().." "..spellId.." "..spellName)
			lib.ResetCleave(spellId)
			cfg.Update=true
--			end
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_INTERRUPTIBLE(u)
		if u=="target" then
			lib.UpdateTargetCast()
			return
		end
	end
	
	Heddevents.UNIT_SPELLCAST_NOT_INTERRUPTIBLE=Heddevents.UNIT_SPELLCAST_INTERRUPTIBLE
	
	function Heddevents.UNIT_SPELLCAST_CHANNEL_START(u, spellName, rank, castid, spellId)
		if u=="player"  then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_CHANNEL_START "..spellName) end
			lib.UpdateChannel(spellId)
			-- lib.SpellSwitchMode()
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_CHANNEL_UPDATE(u, spellName, rank, castid, spellId)
		if u=="player"  then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_CHANNEL_UPDATE "..spellName) end
			lib.UpdateChannel(spellId)
			-- lib.SpellSwitchMode()
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_CHANNEL_STOP(u, spellName, rank, castid, spellId)
		if u=="player"  then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_CHANNEL_STOP "..spellName) end
			lib.UpdateChannel(spellId)
			--lib.SaveCast(spellId)
			-- lib.SpellSwitchMode()
			cfg.Update=true
		end
	end
	
	function Heddevents.COMBAT_LOG_EVENT_UNFILTERED(timeStamp, eventtype,_,sourceGUID,sourceName,_,_,destGUID,destName,_,_,spellId,spellName,_,_,interrupt)
		if eventtype == "UNIT_DIED" or eventtype == "UNIT_DESTROYED" or eventtype == "UNIT_DISSIPATES" then
			lib.RemoveNPC(destGUID)
		end
		if cfg.Cleave then
			if eventtype == "SPELL_DAMAGE" and sourceGUID == cfg.GUID["player"] and spellId and cfg.Id2Cleave[spellId] then
				lib.AddCleaveTarget(spellId,destGUID,timeStamp)
			end
		end
		if cfg.DOT.aura then
			if cfg.HasDOTEvent[eventtype] then
				if spellId == cfg.aura[cfg.DOT.aura].id and sourceGUID == cfg.GUID["player"] then
					lib.AddDOT(destGUID)
				end
			elseif eventtype == "SPELL_AURA_REMOVED" and spellId == cfg.aura[cfg.DOT.aura].id and sourceGUID == cfg.GUID["player"] then
				lib.DelDOT(destGUID)
			end
		end
		if sourceGUID == cfg.GUID["player"] then
			if eventtype == "SPELL_CAST_SUCCESS" then
				if cfg.debugspells then print(GetTime().." COMBATLOG (SPELL_CAST_SUCCESS) "..spellName.." "..spellId) end
				if cfg.id2spell[spellId] and cfg.spells[cfg.id2spell[spellId]] then 
					cfg.spells[cfg.id2spell[spellId]].guid=destGUID
					cfg.spells[cfg.id2spell[spellId]].lastcast=GetTime()
				end
			end
		end
	end
	
	function Heddevents.PLAYER_ENTERING_WORLD()
		Heddevents.PLAYER_TARGET_CHANGED()
		for unitID,_ in pairs(cfg.watchunits) do
			if unitID~="target" then
				Heddevents.UNIT_AURA(unitID)
				Heddevents.UNIT_HEALTH_FREQUENT(unitID)
			end
		end
		Heddevents.UNIT_POWER_FREQUENT("player")
		lib.UpdateShape()
		lib.UpdateAllSpells()
		--lib.UpdateSpell("gcd")
--		lib.instance()
		cfg.Update=true
	end
	
	function Heddevents.PET_BATTLE_OPENING_START()
		if cfg.combat then return end
		if C_PetBattles.IsInBattle() then
			lib.HideFrame(Heddmain)
		end
	end
	
	--Heddevents.PET_BATTLE_OPENING_START=Heddevents.PLAYER_CONTROL_LOST
	
	function Heddevents.PET_BATTLE_CLOSE()
		if cfg.combat then return end
		if not C_PetBattles.IsInBattle() then
			lib.ShowFrame(Heddmain)
		end
	end
	
	--Heddevents.PET_BATTLE_CLOSE=Heddevents.PLAYER_CONTROL_GAINED
	
	function Heddevents.PLAYER_REGEN_DISABLED()
		cfg.combat=true
		lib.MainOptionsToggle()
		lib.ResourceOptionsToggle()
		if cfg.class=="DEATHKNIGHT" then lib.RunesOptionsToggle() end
		cfg.Update=true
	end
	
	function Heddevents.PLAYER_REGEN_ENABLED()
		cfg.combat=false
		lib.UpdateCast()
		lib.MainOptionsToggle()
		lib.ResourceOptionsToggle()
		if cfg.class=="DEATHKNIGHT" then lib.RunesOptionsToggle() end
		lib.CleanNPC()
		cfg.Update=true
		if cfg.combat_reset then
			cfg.combat_reset=false
			Heddtalents_reload()
		end
	end
	
	function Heddevents.UPDATE_SHAPESHIFT_FORM()
		lib.UpdateShape()
		lib.UpdatePower()
		cfg.Update=true
	end
end

local function Hedd_onupdate(self, elapsed)
	cfg.lastUpdate = cfg.lastUpdate + elapsed
	--cfg.now = GetTime()
	if cfg.fixspells_num>0 then lib.FixingSpells() end
	if lib.myonupdate then lib.myonupdate() end
	--if lib.rangecheck then lib.rangecheck() end
	lib.rangecheck()
	lib.UpdateMount()
	if cfg.Update or (cfg.nextUpdate>0 and cfg.nextUpdate<=GetTime()) then -- CD ending doesn't call the event!!!
		if not cfg.Update then
			lib.UpdateAllSpells()
			--lib.UpdateSpell("gcd")
		end
		if cfg.FindPriority then print("Finding priority!") end
		lib.SetPriority()
		cfg.FindPriority=false
		--Heddmain.text:SetText(cfg.mode)
		cfg.lastUpdate = 0
		--print(GetTime().." - Updating!!!")
		cfg.Update=false
		cfg.nextUpdate=lib.GetSpellCDNext()
	end
end


cfg.loaded_1st=nil
function Heddtalents_reload(self,event,...)
	if cfg.loaded_1st and InCombatLockdown() then 
		cfg.combat_reset=true
		--return
	end
	if event=="PLAYER_SPECIALIZATION_CHANGED" and ...~="player" then return end
	if event=="SPELLS_CHANGED" then
		Heddtalents:UnregisterEvent("SPELLS_CHANGED")
	end
	--print("reset on "..event and event or "nothing")
	lib.bdcolor(Heddmain.bd,{0,0,0,0})
	lib.HideFrameChildren(Heddmain.spells)
	if not cfg.combat_reset then
		for index,name in pairs(cfg.spells) do
			--lib.HideFrame(cfg.spells[index].f)
			--if not cfg.combat_reset then
			lib.CDdel(index)
			lib.CDOptionsHide(index)
		end
		lib.HideFrameChildren(Heddframe)
	end
	
	--if not cfg.combat_reset then 
		--Heddframe:Hide()
		--lib.HideFrameChildren(Heddframe)
		--lib.HideFrameChildren(Heddframe.main)
	--end
	lib.RemoveResourceCombo()
	
	--[[lib.defaults()
	lib.SetPower()
	lib.common()]]
	cfg.talenttree = GetSpecialization() or 4
	Heddframe:UnregisterAllEvents()
	Heddframe:SetScript("OnEvent",nil)
	Heddframe:SetScript("OnUpdate",nil)
	--[[if lib.SearchAltPower() then
		lib.basicevents()
		Heddframe:SetScript("OnEvent", function(self, event, ...)
			if cfg.debugevents then
				print(GetTime().." - "..event.." "..((...) and (...) or "no args"))
			end
			if Heddevents[event] then Heddevents[event](...) end
		end)
		Heddframe:RegisterEvent("UNIT_POWER_FREQUENT")
		Heddframe:RegisterEvent("UNIT_AURA")
		Heddevents.UNIT_POWER_FREQUENT("player")
		if not cfg.combat_reset then 
			Heddframe:Show()
		end
	end]]
	--local unit
	
	if lib.classes[cfg.class] and lib.classes[cfg.class][cfg.talenttree] then
		lib.UpdateEquipAll()
		lib.ShowFrameChildren(Heddframe)
		lib.defaults()
		lib.SetPower()
		lib.common()
		cfg.classfound=true
		if lib.classpreload[cfg.class] then lib.classpreload[cfg.class]() end
		lib.classes[cfg.class][cfg.talenttree]()
		lib.basicevents()
		if lib.classpostload[cfg.class] then lib.classpostload[cfg.class]() end
		lib.UpdateShape()
		lib.UpdateSet()
		if lib.mytal then lib.mytal() end
		if not cfg.combat_reset then
			if lib.CD then lib.CD() end
		end
		cfg.plist=cfg.plistdps
		cfg.numcase=0
		for key, value in pairs(cfg.plist) do
			cfg.numcase=cfg.numcase+1
		end
		cfg.numcase=cfg.numcase+1
		
		Heddframe:SetScript("OnEvent", function(self, event, ...)
			if not cfg.classfound then return end
			if cfg.debugevents then
				print(GetTime().." - "..event.." "..((...) and (...) or "no args"))
			end
			if Heddevents[event] then Heddevents[event](...) end
			if Heddclassevents[event] then Heddclassevents[event](...) end
			
		end)

		for k, v in pairs(Heddevents) do
			Heddframe:RegisterEvent(k)
		end
		
		for k, v in pairs(Heddclassevents) do
			Heddframe:RegisterEvent(k)
		end
		Heddframe:SetScript("OnUpdate", Hedd_onupdate)
		
		Heddevents.PLAYER_ENTERING_WORLD()
		if not cfg.combat_reset then 
			Heddframe:Show()
		end
		Heddmain.text:SetText(cfg.mode)
		cfg.loaded_1st=true
	else
		cfg.classfound=nil
	end

end

cfg.notloaded=true
local function Heddframe_pew(self,...)
	if not GetSpellInfo(GetSpellInfo(6603)) then return nil end
	if not GetInventorySlotInfo("MainHandSlot") then return nil end
	
	if cfg.notloaded then
		
		cfg.notloaded=nil
		Heddframe:UnregisterAllEvents()
		Heddframe:SetScript("OnUpdate",nil)
		Heddframe:RegisterForClicks("AnyUp")
		Heddframe:SetScript("OnClick", function (self, button, down)
		if lib.onclick then lib.onclick() end
		end);
		BINDING_HEADER_HEDD_HEADER = "Hedd"
		setglobal("BINDING_NAME_CLICK HEDD_FRAME:LeftButton", "Switch mode dps/aoe")

		Heddtalents:SetScript("OnEvent",Heddtalents_reload)
		Heddtalents:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
		Heddtalents:RegisterEvent("SPELLS_CHANGED")
		--Heddtalents:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		--Heddtalents:RegisterEvent("CHARACTER_POINTS_CHANGED")
		--Heddtalents:RegisterEvent("PLAYER_TALENT_UPDATE")
		--Heddtalents:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		
		--[[Heddtalents:SetScript("OnUpdate",function(...) 
		if (UnitOnTaxi("player") or C_PetBattles.IsInBattle()) then
			if Heddframe:IsShown() then Heddframe:Hide() end
			return
		end
		if not InCombatLockdown() and not Heddframe:IsShown() then
			Heddframe:Show() 
			return
		end
		
		end)]]
		
	end
end

--hooksecurefunc("TalentFrame_Update",function(...) print("TalentFrame_Update") end)
Heddframe:SetScript("OnEvent",Heddframe_pew)
Heddframe:SetScript("OnUpdate",Heddframe_pew)
Heddframe:RegisterEvent("PLAYER_ENTERING_WORLD")
--Heddframe:RegisterEvent("SPELLS_CHANGED")
--Heddframe:RegisterEvent("PLAYER_TALENT_UPDATE")
Heddframe.lib=lib
Heddframe.cfg=cfg

local debug_now=false
if debug_now then
Heddtestevents_frame = Heddtestevents_frame or CreateFrame("Button","HEDD_TEST_EVENTS",UIParent)
Heddtestevents_frame:Show()
Heddtestevents_frame:SetScript("OnEvent", function(self, ...)
	print(...)
	end)

for _, ev in ipairs({
--"PLAYER_CONTROL_LOST",
--"PET_BATTLE_OPENING_START",
--"PLAYER_CONTROL_GAINED",
--"PET_BATTLE_CLOSE",
--"PLAYER_REGEN_DISABLED",
--"PLAYER_REGEN_ENABLED",
--"PLAYER_SPECIALIZATION_CHANGED"

--"UNIT_SPELLCAST_START",
--"UNIT_SPELLCAST_INTERRUPTED",
--"UNIT_SPELLCAST_DELAYED",
--"UNIT_SPELLCAST_STOP",
"UNIT_AURA"
--"UNIT_SPELLCAST_SUCCEEDED"
--"PLAYER_SPECIALIZATION_CHANGED",
--"PLAYER_TALENT_UPDATE",
--"SPELLS_CHANGED",
--"PLAYER_ENTERING_WORLD"
}) do
	Heddtestevents_frame:RegisterEvent(ev)
end
end